<bugID>1195386<Summary>[e10s][meta] built-in framescripts register observers for each tab</Summary><Description>I'm seeing the following in my profile with ~1600 tabs (most of them lazy-loaded):

54,570 (100.0%) -- observer-service-suspect
&#9500;&#9472;&#9472;&#9472;5,167 (09.47%) &#9472;&#9472; referent(topic=memory-pressure)
&#9500;&#9472;&#9472;&#9472;3,487 (06.39%) &#9472;&#9472; referent(topic=xpcom-shutdown)
&#9500;&#9472;&#9472;&#9472;3,387 (06.21%) &#9472;&#9472; referent(topic=before-first-paint)
&#9500;&#9472;&#9472;&#9472;1,726 (03.16%) &#9472;&#9472; referent(topic=chrome-flush-skin-caches)
&#9500;&#9472;&#9472;&#9472;1,723 (03.16%) &#9472;&#9472; referent(topic=agent-sheet-added)
&#9500;&#9472;&#9472;&#9472;1,723 (03.16%) &#9472;&#9472; referent(topic=agent-sheet-removed)
&#9500;&#9472;&#9472;&#9472;1,723 (03.16%) &#9472;&#9472; referent(topic=author-sheet-added)
&#9500;&#9472;&#9472;&#9472;1,723 (03.16%) &#9472;&#9472; referent(topic=author-sheet-removed)
&#9500;&#9472;&#9472;&#9472;1,723 (03.16%) &#9472;&#9472; referent(topic=user-sheet-added)
&#9500;&#9472;&#9472;&#9472;1,723 (03.16%) &#9472;&#9472; referent(topic=user-sheet-removed)
&#9500;&#9472;&#9472;&#9472;1,701 (03.12%) &#9472;&#9472; referent(topic=network:offline-status-changed)
&#9500;&#9472;&#9472;&#9472;1,700 (03.12%) &#9472;&#9472; referent(topic=dom-storage2-changed)
&#9500;&#9472;&#9472;&#9472;1,695 (03.11%) &#9472;&#9472; referent(topic=sdk:loader:destroy)
&#9500;&#9472;&#9472;&#9472;1,693 (03.10%) &#9472;&#9472; referent(topic=app-theme-changed)
&#9500;&#9472;&#9472;&#9472;1,692 (03.10%) &#9472;&#9472; referent(topic=browser:purge-domain-data)
&#9500;&#9472;&#9472;&#9472;1,692 (03.10%) &#9472;&#9472; referent(topic=earlyformsubmit)
&#9500;&#9472;&#9472;&#9472;1,691 (03.10%) &#9472;&#9472; referent(topic=audio-playback)
&#9500;&#9472;&#9472;&#9472;1,691 (03.10%) &#9472;&#9472; referent(topic=audiochannel-activity-alarm)
&#9500;&#9472;&#9472;&#9472;1,691 (03.10%) &#9472;&#9472; referent(topic=audiochannel-activity-content)
&#9500;&#9472;&#9472;&#9472;1,691 (03.10%) &#9472;&#9472; referent(topic=audiochannel-activity-normal)
&#9500;&#9472;&#9472;&#9472;1,691 (03.10%) &#9472;&#9472; referent(topic=audiochannel-activity-notification)
&#9500;&#9472;&#9472;&#9472;1,691 (03.10%) &#9472;&#9472; referent(topic=audiochannel-activity-publicnotification)
&#9500;&#9472;&#9472;&#9472;1,691 (03.10%) &#9472;&#9472; referent(topic=audiochannel-activity-ringer)
&#9500;&#9472;&#9472;&#9472;1,691 (03.10%) &#9472;&#9472; referent(topic=audiochannel-activity-telephony)
&#9500;&#9472;&#9472;&#9472;1,691 (03.10%) &#9472;&#9472; referent(topic=author-style-disabled-changed)
&#9500;&#9472;&#9472;&#9472;1,691 (03.10%) &#9472;&#9472; referent(topic=invalidformsubmit)
&#9500;&#9472;&#9472;&#9472;1,691 (03.10%) &#9472;&#9472; referent(topic=keyword-uri-fixup)
&#9492;&#9472;&#9472;&#9472;1,691 (03.10%) &#9472;&#9472; referent(topic=style-sheet-applicable-state-changed)




For example the topic "earlyformsubmit" is registered by the framescript chrome://satchel/content/formSubmitListener.js


Since the observer service has to notify each callback this results in O(n) runtime each time some tab triggers the observer service even though almost all callbacks bail out early and only one of the frame scripts actually handles it.

By registering them in a process script or JSM and resolving back to a tab-specific callback with a hash map or by walking the doc tree up to the frame message manager where needed this could be reduced to O(1).</Description></bugID>